
ai_timer -= 1;

if ((ai_timer <= 0) && (!is_shooting))
{
    ai_timer = 60 + random(60);
    facing_dir = -1;
    if (x < room_width / 2)
        facing_dir = 1;
    if (instance_number(o_bc_player) > 0)
    {
        var enemy_nearest = instance_nearest(x,y,o_bc_player);
        if (enemy_nearest.x < x)
            facing_dir = -1;
            else 
            facing_dir = 1;
    }
    
    if ((random(100) < 80) && on_floor)
    {
        is_shooting = true;
        shoot_bullets = shoot_bullets_max;
        shoot_delay = shoot_delay_max;
    }
}


xspd = mov_spd * facing_dir;

if (x < half_width)
{
    facing_dir = 1;
    xspd = mov_spd;
    }

if (x > room_width - half_width)
{
    facing_dir = -1;
    xspd = -mov_spd;
    }
    
if (has_parachute)
{
    if (yspd > 2)
        yspd = 2;    
 }
 
if (!on_floor)
    is_shooting = false;
        
if (is_shooting)
{
    xspd = 0;
    shoot_delay -= 1;
    if ((shoot_delay <= 0) && (shoot_bullets > 0))
    {
        shoot_bullets--;
        var bullet = instance_create(x,y,o_bc_enemybullet);
        bullet.xspd = bullet_speed * facing_dir;
        bullet.image_blend = c_red;
        
        
        shoot_delay = shoot_delay_max;
    }
    
    if ((shoot_bullets <= 0) && (shoot_delay <= 0))
    {
        is_shooting = false;
        shoot_delay = shoot_delay_max;
        
    }
}
    
scr_bc_move();

jump_check--;
if ((jump_check <= 0) && (!is_shooting))
{
    jump_check = 60 + random(180)
    if (on_floor)
    {
        yspd = -jumpspd;
    }
}

if (!on_floor)
{
    image_index = 1;
}
else 
{
    if (has_parachute)
    {
        has_parachute = false;
        instance_create(x,y-48, o_bc_parachute_fall);
        }
}

if (y > room_height + 100)
    instance_destroy();
