if (!is_dead)
{
    check_keys();
    
    //aimdir = 0;
    
    if (key_up)
    {
        aim_dir = 90;
    }
    
    xspd = 0;
    
    if (key_left)
    {
        xspd = -mov_spd;
        facing_dir = -1;
        step_img+= anim_spd;
        
        if (key_up)
            aim_dir = 135;
        else if (key_down)
            aim_dir = 225;
        else
            aim_dir = 180;
    }
    if (key_right)
    {
        if (!key_down)
            xspd = mov_spd;
        step_img+=anim_spd;
        facing_dir = 1;
        
        if (key_up)
            aim_dir = 45;
        else if (key_down)
            aim_dir = 315;
        else 
            aim_dir = 0;
    }
    
    is_prone = false;
    if (key_down)
    {
        if (on_floor)
        {
            is_prone = true;
            xspd = 0;
            if (facing_dir == 1)
                aim_dir = 0;
            else 
                aim_dir = 180;
        }
        else 
        {
            if ((!key_left) && (!key_right))
                aim_dir = 270;
        }
    }
    
    if (key_buttona)//_pressed)
    {
        if (on_floor)
        {
            yspd = -jumpspd;
        }
    }
    
    shoot_time-=1;
    if (key_buttonb)
    {
        if (shoot_time <= 0)
        {
            var upgrades_spread = 4 * upgrades;
            //var upgrades_angle = upgrades * upgrades_spread;
            var upgrades_angle_diff = upgrades_spread / (upgrades+1);
                
            var curr_angle = aim_dir - (upgrades_spread / 2);
            
            show_debug_message("Shooting with " + string(upgrades) + " upgrades.");
            show_debug_message("upgrades_spread = " + string(upgrades_spread) + ", upgades_angle_diff = " + string(upgrades_angle_diff));
            for (var i = 0; i < upgrades + 1; ++i)
            {
                var bullet = instance_create(x,y,o_bc_bullet);
                
                bullet.x = x + lengthdir_x(8, aim_dir);
                if (is_prone)
                    bullet.y = y + 21 + lengthdir_y(8, aim_dir);
                else
                    bullet.y = y - 12 + lengthdir_y(8, aim_dir);
                        
                bullet.xspd = lengthdir_x(bullet_speed, curr_angle);
                bullet.yspd = lengthdir_y(bullet_speed, curr_angle);
                bullet.damage = bullet_damage;
                
                
                show_debug_message("bullet " + string(i) + " angle = " + string(curr_angle));
                
                curr_angle += upgrades_angle_diff;
            }
    
            shoot_time = shoot_delay;
                    
            /*
            for (var i = 0; i < max_bullets; ++i)
            {
                if (!instance_exists(bullets[i]))
                {
                    bullets[i] = instance_create(x,y,o_bc_bullet);
                    
                    bullets[i].player_id = player_id;
                    bullets[i].xspd = lengthdir_x(bullet_speed, aim_dir);
                    bullets[i].yspd = lengthdir_y(bullet_speed, aim_dir);
                    bullets[i].damage = bullet_damage;
                    
                    shoot_time = shoot_delay;
                    break;
                }
                else 
                {
                   // show_debug_message("instance exists " + string(bullets[i]));
                }
            }
                */
        }
        
    }
    
    if (is_prone)
    {
        mask_index = s_bc_plr_prone_hitbox;
    }
    else 
        mask_index = s_bc_plr_stand_hitbox;
        
    if (!on_floor)
        step_img = 1;
    
    scr_bc_move();
    
    image_alpha = 1;
    if (is_dead)
    {
        spawn_delay -= 1;
        image_alpha = 0.5;
    }
    
    if (x < half_width)
        x = half_width;
    
    if (x > room_width - half_width)
        x = room_width - half_width;
        
}
