if (match_ended)
{
    end_of_match_time--;
    if (end_of_match_time <= 0)
    {
        room_goto(catrace_game_winner);
    }
}
else
{
    global.catrace_time += 1;
}


var xborder = 300;
var yborder = 300;

var minx = room_width;
var miny = room_height;
var maxx = 0;
var maxy = 0;
var xtotal = 0;
var ytotal = 0;
for (var i = 0; i < num_players; ++i)
{
    if (player[i].x < minx)
        minx = player[i].x;
    if (player[i].y < miny)
        miny = player[i].y; 
    if (player[i].x > maxx)
        maxx = player[i].x;
    if (player[i].y > maxy)
        maxy = player[i].y;
    xtotal += player[i].x;
    ytotal += player[i].y;
    
    if (!match_ended)
    {
        if (playerscore[i] >= laps)
        {
            match_ended = true;
            global.last_game_winner = i;
            
            for (var j = 0; j < num_players; ++j)
            {
                if (j != i)
                {
                    player[j].life = 0;
                }
            }

        }
    }
}
xtotal /= num_players;
ytotal /= num_players;

//show_debug_message("minx = " + string(minx));
//show_debug_message("miny = " + string(miny));
//show_debug_message("maxx = " + string(maxx));
//show_debug_message("maxy = " + string(maxy));

var view_hsize_max = room_width;
var view_vsize_max = room_height;
var view_hsize_min = 960;
var view_vsize_min = 540;

minx -= xborder;
maxx += xborder;
miny -= yborder;
maxy += yborder;

targ_x_wid = ((maxx - minx) / view_hsize_max) * view_hsize_max;
targ_y_wid = ((maxy - miny) / view_vsize_max) * view_vsize_max;

if (targ_x_wid < view_hsize_min) 
    targ_x_wid = view_hsize_min;

if (targ_y_wid < view_vsize_min) 
    targ_y_wid = view_vsize_min;

//show_debug_message("targ_x_wid = " + string(targ_x_wid));
//show_debug_message("targ_y_wid = " + string(targ_y_wid));
    
var view_scale_x = targ_x_wid / view_hsize_max;
var view_scale_y = targ_y_wid / view_vsize_max;

if (view_scale_x > view_scale_y)
    targ_y_wid = view_scale_x * view_vsize_max;
else if (view_scale_y > view_scale_x)
    targ_x_wid = view_scale_y * view_hsize_max;
    
//show_debug_message("view_scale_x = " + string(view_scale_x));
//show_debug_message("view_scale_y = " + string(view_scale_y));

view_wview[view_current] = targ_x_wid;
view_hview[view_current] = targ_y_wid;

var xview_calc = (minx + ((maxx - minx) / 2)) - (targ_x_wid / 2);
var yview_calc = (miny + ((maxy - miny) / 2)) - (targ_y_wid / 2);
view_xview[view_current] = xview_calc;
view_yview[view_current] = yview_calc;


//show_debug_message("xview_calc = " + string(xview_calc));
//show_debug_message("yview_calc = " + string(yview_calc));

/*
var targx = ( (maxx - minx) / view_hsize_max);
var targy = ( (maxy - miny) / view_vsize_max);

if ((targx * view_hsize_max) < view_hsize_min) 
    targx = view_hsize_min / view_hsize_max;

if ((targy * view_vsize_max) < view_vsize_min) 
    targy = view_vsize_min / view_vsize_max;
    
view_wview[view_current] = targx * view_hsize_max;
view_hview[view_current] = targy * view_vsize_max;
*/

/*
view_xview[view_current] = xtotal - (960 / 2);
view_yview[view_current] = ytotal - (540 / 2);
*/
