if (!is_dead)
{
check_keys();

var rot_acc_modified = rotspd_acc;
var acc_modified = acc;
var rot_fric_modified = rot_fric;

var spd = sqrt((xspd*xspd) + (yspd*yspd));
var facing_vec_x = lengthdir_x(1, rot);
var facing_vec_y = lengthdir_y(1, rot);
var moving_vec_x = xspd/spd;
var moving_vec_y = yspd/spd;

var facing_dot = dot_product(facing_vec_x,facing_vec_y,moving_vec_x,moving_vec_y);

if (!key_buttona)
    rot_acc_modified *= 2; //Turn faster when not accelerating!
if (facing_dot < - 0.5)
    acc_modified *= 3; // Fast brake!
else if (!key_left && !key_right)
    acc_modified *= 2; // Faster when not turning!

if (key_left)
{
    if (rotspd < rotspd_max)
    {
        rotspd += rot_acc_modified;
    }
}

if (key_right)
{
    if (rotspd > -rotspd_max)
    {
        rotspd -= rot_acc_modified;
    }
}

hit_timer--;
if (hit_timer > 0)
{
    rot_fric_modified = rot_fric_mod_src;
}
rotspd *= rot_fric_modified;

is_accelerating = false;
if (key_buttona)
{
    xspd += lengthdir_x(acc_modified, rot);
    yspd += lengthdir_y(acc_modified, rot);
    
    is_accelerating = true;
    
    var xxxx = lengthdir_x(1, rot+180);
    var yyyy = lengthdir_y(1, rot+180);
    var trail = instance_create(x+(xxxx*10),y+(yyyy * 10),o_spc_trail);
    trail.hspeed = (xspd * 0.4) + xxxx;
    trail.vspeed = (yspd * 0.4) + yyyy;
}

shoot_time -= 1;

if (key_buttonb)
{
    if (shoot_time <= 0)
    {
        for (var i = 0; i < max_bullets; ++i)
        {
            if (!instance_exists(bullets[i]))
            {
                var spd = sqrt(((xspd * xspd) + (yspd * yspd)));
                bullets[i] = instance_create(x,y,o_spc_bullet);
                bullets[i].player_id = player_id;
                //bullets[i].image_blend = image_blend;
                bullets[i].rot = rot;
                //bullets[i].xspd = xspd;
                bullets[i].xspd = lengthdir_x(bullet_speed+spd, rot);
                //bullets[i].yspd = yspd;
                bullets[i].yspd = lengthdir_y(bullet_speed+spd, rot);
                
                var xxspd = (bullets[i].xspd * bullets[i].xspd);
                var yyspd = (bullets[i].yspd * bullets[i].yspd);
                var bltspd = sqrt(xxspd + yyspd);
                
                if (bltspd > huge_bullet_spd)
                {
                    bullets[i].sprite_index = spr_bullet_03;
                    //bullets[i].image_angle = point_direction(0,0,bullets[i].xspd, bullets[i].yspd);
                    bullets[i].bullet_power *= 1.2;
                }
                else if (bltspd > big_bullet_spd)
                {
                    bullets[i].sprite_index = spr_bullet_02;
                    //bullets[i].image_angle = point_direction(0,0,bullets[i].xspd, bullets[i].yspd);
                    bullets[i].bullet_power *= 1.5;
                }
                    bullets[i].image_angle = point_direction(0,0,bullets[i].xspd, bullets[i].yspd);
                shoot_time = shoot_delay;
                break;
            }
            else 
            {
               // show_debug_message("instance exists " + string(bullets[i]));
            }
        }
    }
}

spd = sqrt((xspd*xspd) + (yspd*yspd));
spd *= spd_fric;
var move_dir = point_direction(0, 0, xspd, yspd);
xspd = lengthdir_x(spd, move_dir);
yspd = lengthdir_y(spd, move_dir);

scr_spc_move();

invincible_delay -= 1;
if (invincible_delay > 0)
    image_alpha = 0.5;
    else 
    image_alpha = 1;
collision_time -= 1;

}
