game_phase= GAME_PHASE_BOMB;

randomize();

totalmoves = 5;

turn = 1;

input_freeze_max = 30;
input_freeze = 30;

turn_time_minimum = 15;
turn_time_per_turn = 1;
turn_timer = (60 * turn_time_per_turn * turn) + (turn_time_minimum * 60);

grid_size_x = 20;
grid_size_y = 12;

grid_start_pos_x = 256;
grid_start_pos_y = 64;


num_players = joy_count();
for (var i = 0; i < num_players; ++i)
{
    
    playerav[i] = instance_create(grid_start_pos_x + (32 * i),
                                grid_start_pos_y - 32,
                                o_z_player_avatar);
    playerav[i].player_id = i;
    playerav[i].image_blend = global.col[i];
    
    
    player[i] = instance_create(grid_start_pos_x + (32 * i),
                                grid_start_pos_y - 32,
                                o_z_player);
    player[i].player_id = i;
    player[i].image_blend = global.col[i];
    player[i].moves = totalmoves;
    player[i].avatar = playerav[i];
}

for (var xx = 0; xx < grid_size_x; ++xx)
{
    for (var yy = 0; yy < grid_size_y; ++yy)
    {
        grid[xx,yy] = instance_create(grid_start_pos_x + (32 * xx),
                                        grid_start_pos_y + (32 * yy),
                                         o_z_tile);
        grid[xx,yy].flipped = false;
    }
}

var totalgrids = grid_size_x * grid_size_y;
grid_divided = floor(totalgrids / num_players);

for (var i = 0; i < num_players; ++i)
{
    var gridindex = floor((grid_divided * i) + floor(random(grid_divided)));
    var gridx = gridindex mod grid_size_x;
    var gridy = floor(gridindex / grid_size_x);
    
    playerav[i].x = grid[gridx, gridy].x;
    playerav[i].y = grid[gridx, gridy].y;
    player[i].x = playerav[i].x;
    player[i].y = playerav[i].y;
}

bomb_delay = 0;
move_delay = 0;
run_delay = 0;

game_end_delay = 120;
game_ended = false;
