end_of_round_timer -= 1;
spawn_delay -= 1;
if (((left_to_spawn > 0) || (left_to_spawn_gun > 0)) && (end_of_round_timer <= 0) && (spawn_delay<= 0))
{
    var spawners_count = instance_number(o_bc_enemyspawn);
    for (var i = 0; i < spawners_count; ++i)
    {
        if ((left_to_spawn <= 0) && (left_to_spawn_gun <= 0))
            break;
            
        var spawner = instance_find(o_bc_enemyspawn, i);
        if (spawner.spawntimer <= 0)
        {
            var badapple = -1;
            
            if (left_to_spawn > 0)
            {
                badapple = instance_create(spawner.x, spawner.y, enemytype);
                badapple.life = 5 + (5 * wave);
                left_to_spawn -= 1;
                spawn_delay = 15;
            }
            
            if (left_to_spawn_gun > 0)
            {
                badapple = instance_create(spawner.x, spawner.y, o_bc_enemy_02);
                badapple.life = 30 + (10 * wave);
                left_to_spawn_gun -= 1;
                spawn_delay = 15;
            }
            
            if (badapple != -1)
            {
                spawner.spawntimer = 60;
                if (badapple.x > (room_width/2))
                    badapple.facing_dir = -1;
                else 
                    badapple.facing_dir = 1;
                if (badapple.y < 0)
                    badapple.has_parachute = true;
            }
        }
    }
    
    var powerupspawns = instance_number(o_bc_powerup_spawn);
    var randspawn = floor(random(powerupspawns));
    for (var i = 0; i < powerupspawns; ++i)
    {
        var spawner = instance_find(o_bc_powerup_spawn, randspawn);
        
        if (spawner.child == -1)
        {
            spawner.child = instance_create(spawner.x, spawner.y, o_bc_powerup);
            spawner.child.parent = spawner;
            break;
        }
        
        randspawn++;
        randspawn = randspawn mod powerupspawns;
        
    }
}
else if (left_to_spawn <= 0)
{
    if (instance_number(o_bc_enemy) <= 0)
    {
        wave += 1;
        end_of_round_timer = 120;
        left_to_spawn = 2 * wave + 1;
        left_to_spawn_gun = wave - 2;
        
        var wav = instance_create(0, 0, o_bc_wave_counter);
        wav.scoreval = wave;
        
        for (var i = 0; i < num_players; ++i)
        {
            if (player[i].is_dead)
            {
                with(player[i])
                {
                    scr_bc_player_reset();                
                }
            }
        }
    }
}

var survivors = 0;
for (var i = 0; i < num_players; ++i)
{
    if (!player[i].is_dead)
    {
        survivors++;
    }
}

if (survivors == 0)
{
    game_over_timer--;
    if (game_over_timer <= 0)
    {
        global.contra_wave = wave;
        global.contra_kills = enemykills;
        room_goto(bananacontra_end);
    }

}
