if ((!is_dead) && life < 90 && place_meeting(x,y,o_cr_scratchpost) && o_cr_scratchpost.cat == -1)
{
    is_scratching = true;
    o_cr_scratchpost.cat = id;
}

if ((!is_dead) && (!is_scratching))
{
    check_keys();
    
    
    var rot_acc_modified = rotspd_acc;
    var acc_modified = acc;
    var rot_fric_modified = rot_fric;
    var spd_fric_modified = spd_fric;
    
    var temp = (xspd*xspd) + (yspd*yspd);
    //show_debug_message("temp: " + string(temp));
    if (temp == 0)
        spd = 0;
    else
        spd = sqrt(temp);
    var facing_vec_x = lengthdir_x(1, rot);
    var facing_vec_y = lengthdir_y(1, rot);
    var moving_vec_x = xspd/spd;
    var moving_vec_y = yspd/spd;
    
    var facing_dot = dot_product(facing_vec_x,facing_vec_y,moving_vec_x,moving_vec_y);
    
    braking = key_buttonb;
    
    //if (!key_buttona)
    //    rot_acc_modified *= 2; //Turn faster when not accelerating!
    
    
    //if (facing_dot < - 0.5)
    //    acc_modified *= 3; // Fast brake!
    //else if (!key_left && !key_right)
    //    acc_modified *= 2; // Faster when not turning!
    
    if (braking)
    {
        if (facing_dot > 0)
        {
            rot_acc_modified *= 3; 
        }
        else 
        {
            rot_acc_modified *= 0.1; 
        }
        
        rot_fric_modified = 0.65;
        
        /*
        if (!key_left && !key_right && (facing_dot > 0.85))
        {
            spd_fric_modified = 0.94;
        }
        else 
        {
            //acc_modified *= 0.8;
            spd_fric_modified = 0.999;
        }
        */
        
    }
    if (!braking && facing_dot > 0.8)
    {
        spd_fric_modified = 0.98;
    }
    if (!braking && facing_dot > 0.8)
    {
        acc_modified *= 1.2; // Faster when going straight!
    }
    //if (!key_left && !key_right && !braking)
    //    acc_modified *= 1.2; // Faster when not turning!
    
    if (key_left)
    {
        if (rotspd < rotspd_max)
        {
            rotspd += rot_acc_modified;
        }
    }
    
    if (key_right)
    {
        if (rotspd > -rotspd_max)
        {
            rotspd -= rot_acc_modified;
        }
    }
    
    hit_timer--;
    if (hit_timer > 0)
    {
        rot_fric_modified = rot_fric_mod_src;
    }
    rotspd *= rot_fric_modified;
    
    is_accelerating = false;
    if (key_buttona)
    {
        xspd += lengthdir_x(acc_modified, rot);
        yspd += lengthdir_y(acc_modified, rot);
        
        is_accelerating = true;
        
        var xxxx = lengthdir_x(1, rot+180);
        var yyyy = lengthdir_y(1, rot+180);
        var trail = instance_create(x+(xxxx*10),y+(yyyy * 10),o_spc_trail);
        trail.hspeed = (xspd * 0.4) + xxxx;
        trail.vspeed = (yspd * 0.4) + yyyy;
    }
    
    spd = sqrt((xspd*xspd) + (yspd*yspd));
    spd *= spd_fric_modified;
    var move_dir = point_direction(0, 0, xspd, yspd);
    xspd = lengthdir_x(spd, move_dir);
    yspd = lengthdir_y(spd, move_dir);
    
    rot += rotspd;
    rot = rot % 360;
    
    var xprev = x;
    var yprev = y;
    x+=xspd;
    y+=yspd;
    
    var wallcount = instance_number(o_cr_wall);
    
    for (var i = 0; i < wallcount; ++i)
    {
        var wall = instance_find(o_cr_wall, i);
        
        if (collision_line(wall.xpos1, wall.ypos1, wall.xpos2, wall.ypos2, id, true, false))
        {
            x = xprev;
            y = yprev;
            var norm_spd_x = xspd;
            var norm_spd_y = yspd;
            
            show_debug_message("in the wall");
            
            var len_spd = (xspd * xspd) + (yspd * yspd)
            if (len_spd > 0)
            {
                len_spd = sqrt(len_spd);
                
                
            show_debug_message("len_spd = " + string(len_spd));
                
                norm_spd_x /= len_spd;
                norm_spd_y /= len_spd;
                
                var norm_x = wall.normal_x;
                var norm_y = wall.normal_y;
                
                var n_dot_v = dot_product(norm_spd_x, norm_spd_y, norm_x, norm_y);
                
                xspd = (-2 * (n_dot_v * norm_x)) * (len_spd * 0.5);
                yspd = (-2 * (n_dot_v * norm_y)) * (len_spd * 0.5);
                
                life -= len_spd;
            }
        
        }
    
    }
    
    if (braking && spd > 1)
    {
        if (random(100) < 25)
        {
        smoke = instance_create(x + lengthdir_x(15,rot+180),y+ lengthdir_x(15,rot+180),o_cr_catsmoke);
        smoke.direction = rot + 180;
        smoke.speed = random(4);
        }
    }
    
    if (spd > 2 && (braking || facing_dot < 0.6))
    {
        var skid = instance_create(x,y,o_cr_catskid);
        skid.image_angle = rot;
        
    }
    
    /*
    var obs = instance_place(x,y,o_cr_obstacle);
    if (obs != noone)
    {
        x = xprev;
        y = yprev;
        var coll_x = (x + obs.x)/2
        var coll_y = (y + obs.y)/2
        var norm_x = obs.x - coll_x;
        var norm_y = obs.y - coll_y;
        var norm_spd_x = xspd;
        var norm_spd_y = yspd;
        
        var len_spd = sqrt((xspd * xspd) + (yspd * yspd));
        norm_spd_x /= len_spd;
        norm_spd_y /= len_spd;
        
        var len_norm = sqrt((norm_x * norm_x) + (norm_y * norm_y));
        norm_x /= len_norm;
        norm_y /= len_norm;
        
        var n_dot_v = dot_product(norm_spd_x, norm_spd_y, norm_x, norm_y);
        
        xspd = (-2 * (n_dot_v * norm_x)) * (len_spd * 0.5);
        yspd = (-2 * (n_dot_v * norm_y)) * (len_spd * 0.5);
        
        life -= len_spd;
        
        //−2((n · v) n + v))
        
        //return vector - 2 * Vector2.Dot(vector, normal) * normal;
        //dot_product(
    
    //newVelX1 = (firstBall.speed.x * (firstBall.mass – secondBall.mass) + (2 * secondBall.mass * secondBall.speed.x)) / (firstBall.mass + secondBall.mass);
    //newVelY1 = (firstBall.speed.y * (firstBall.mass – secondBall.mass) + (2 * secondBall.mass * secondBall.speed.y)) / (firstBall.mass + secondBall.mass);
    }
    */
    
    invincible_delay -= 1;
    if (invincible_delay > 0)
        image_alpha = 0.5;
        else 
        image_alpha = 1;
    collision_time -= 1;
    
    var img_spd_mult = spd / 50;
    img+=img_spd_mult;//img_spd ;
    
    if (x < 32) x = 32;
    if (x > room_width-32) x = room_width-32;
    if (y < 32) y = 32;
    if (y > room_height-32) y = room_height-32;
    
    rot = (rot + 36000) mod 360;

}

if (is_scratching)
{
    x = o_cr_scratchpost.x;
    y = o_cr_scratchpost.y;
    life += 0.4;
    if (life >= 100)
    {
        life = 100;
        is_scratching = false;
        rot = 340;
        xspd = 0;
        yspd = 0;
        o_cr_scratchpost.cat = -1;
    }
}

if (is_dead)
{
    respawn_timer-= 1;
    if (respawn_timer <= 0)
    {
        if (checkpoint != -1)
        {
            x = checkpoint.x;
            y = checkpoint.y;
            rot = checkpoint_dir;
        }
        else
        {
            x = o_cr_goal.x;
            y = o_cr_goal.y;
            rot = 180;
        }
        is_dead = false;
        xspd = 0;
        yspd = 0;
        rotspd = 0;
        invincible_delay = 120;
    }
}

if (life <= 0) 
{
    is_dead = true;
    life = 100;
    
    instance_create(x,y,o_cr_explosion);
    
    respawn_timer = 120;
}

