if (game_phase == GAME_PHASE_EXPLODE)
{
    if (game_ended)
    {
        game_end_delay -= 1;
        if (game_end_delay <= 0)
        {
            room_goto(grid_game_winner);
        }
    }
    else 
    {
        
        var found_any = false;
        
        bomb_delay--;
        if (bomb_delay <= 0)
        {
            for (var i = 0; i < instance_number(o_z_tile); ++i)
            {
                if (bomb_delay <= 0)
                {
                    var tile = instance_find(o_z_tile, i);
                    if (tile.pending_flip)
                    {
                        tile.flipped = true;
                        tile.pending_flip = false;
                        bomb_delay = 10;
                        found_any = true;
                        break;
                    }
                }
            }
            
            if (!found_any)
            {
                var left_alive = 0;
                global.last_game_winner = -1;
                
                for (var i = 0; i < num_players; ++i)
                {
                    if (!player[i].is_dead)
                    {
                        left_alive += 1;
                        global.last_game_winner = i;
                    }
                }
                if (left_alive <= 1)
                {
                    game_ended = true;
                    game_end_delay = 120;
                }
                else 
                {
                    // next round!
                    
                    turn++;
                    turn_timer = (60 * turn_time_per_turn * turn) + (turn_time_minimum * 60);
                    for (var i = 0; i < num_players; ++i)
                    {
                        player[i].moves += totalmoves; //turns
                        player[i].x = player[i].avatar.x;
                        player[i].y = player[i].avatar.y;
                    }
                
                    game_phase = GAME_PHASE_BOMB;
                    bomb_delay = 10;
                    input_freeze = input_freeze_max;
                    
                }
            }
        }
    }
}
